// This may look like C code, but it is really -*- C++ -*-
/****************************************************************************
** $Id: fancyarray.h 194 2009-02-27 17:59:29Z wglas $
**
** Copyright (C) 2003 EV-i Informationstechnologie GmbH
**
** Author: Wolfgang Glas / EV-i
**
** An allocated array.
** 
*****************************************************************************/

#ifndef FANCYBASE_ARRAY_H
#define FANCYBASE_ARRAY_H

#include <fancybase.h>

namespace Fancy {

  template<class T> class Array
  {
    T *t;

  public:
    Array(size_t sz) : t(new T[sz]) {}

    ~Array() { delete[] t; }

    const T &operator[] (size_t i) const { return t[i]; }
    T &operator[] (size_t i) { return t[i]; }
  };

}

#endif
