// This may look like C code, but it is really -*- C++ -*-
/****************************************************************************
** $Id: fancybaselog.h 87 2007-12-18 17:11:32Z wglas $
**
** Copyright (C) 2003 EV-i Informationstechnologie GmbH
**
** Author: Wolfgang Glas / EV-i
**
** Global logging stuff.
** 
*****************************************************************************/

#ifndef FANCYBASE_LOG_H
#define FANCYBASE_LOG_H

#include <fancylog.h>
#include <fancybase.h>

  // facility masks.
#define  FANCYBASE_LOG_STDCXX    (1<<0)
#define  FANCYBASE_LOG_LIBC      (1<<1)
#define  FANCYBASE_LOG_THREAD    (1<<2)
#define  FANCYBASE_LOG_CACHE     (1<<3)
#define  FANCYBASE_LOG_APP       (1<<4)

namespace Fancy {
  extern FANCYBASE_API fancylog_service *log_service;

  // parse for logging cmdline args and filter out recognized options.
  void FANCYBASE_API fancylog_parse_arg (int *argc, char **argv);

  inline void vfancylog (int facility,
                         int priority, const char *fmt, va_list ap)
  {
    va_list aq;
    va_copy(aq,ap);
    ::vfancylog(log_service,facility,priority,fmt,aq);
    va_end(aq);
  }
  
#ifdef __GNUG__
  inline void fancylog (int facility,
                        int priority, const char *fmt, ...)
    __attribute__((format(printf,3,4)));
    
#endif

  inline void fancylog (int facility,
                        int priority, const char *fmt, ...)
  {
    va_list ap;
    va_start(ap, fmt);
    vfancylog(facility,priority,fmt,ap);
    va_end(ap);
  }
}

#endif // ! FANCYBASE_LOG_H
