// This may look like C code, but it is really -*- C++ -*-
/****************************************************************************
** $Id: fancythread.h 2 2006-01-14 14:09:11Z wglas $
**
** Copyright (C) 2003 EV-i Informationstechnologie GmbH
**
** Author: Wolfgang Glas / EV-i
**
** Class for reading config files.
** 
*****************************************************************************/

#ifndef FANCYBASE_CONFIG_H
#define FANCYBASE_CONFIG_H

#include <string>
#include <fancybase.h>

namespace Fancy {

  class ConfigOptionsImpl;

  class FANCYBASE_API ConfigOptions
  {
  public:
    ConfigOptions(const std::string &ctxt);
    ~ConfigOptions();

    void loadFile(const std::string &fn);
    void parseCmdLine(int &argc, char **argv);

    std::string getValue (const std::string &nm, const std::string &def) const;
    bool        getBool  (const std::string &nm, bool def) const;
    int         getInt   (const std::string &nm, int def) const;
    unsigned    getUInt  (const std::string &nm, unsigned def) const;
    double      getDouble(const std::string &nm, double def) const;

    std::string getValue (const std::string &nm) const;
    bool        getBool  (const std::string &nm) const;
    int         getInt   (const std::string &nm) const;
    unsigned    getUInt  (const std::string &nm) const;
    double      getDouble(const std::string &nm) const;

  private:
    ConfigOptions(const ConfigOptions &);
    ConfigOptions &operator=(const ConfigOptions &);

    ConfigOptionsImpl *d;
  };

}

#endif // ! FANCYBASE_CONFIG_H
