// This may look like C code, but it is really -*- C++ -*-
/****************************************************************************
** $Id: fancythread.h 2 2006-01-14 14:09:11Z wglas $
**
** Copyright (C) 2003 EV-i Informationstechnologie GmbH
**
** Author: Wolfgang Glas / EV-i
**
** Classes for string conversions.
** 
*****************************************************************************/

#ifndef FANCYBASE_NUMERICCONVERTER_H
#define FANCYBASE_NUMERICCONVERTER_H

#include <string>
#include <locale>
#include <fancybase.h>

namespace Fancy {

  class FANCYBASE_API NumericConverter
  {
  public:
    NumericConverter();
    NumericConverter(const std::locale &l);
    ~NumericConverter();

    void imbue(const std::locale &l);

    bool     toBool(const std::string &s) const;
    int      toInt(const std::string &s) const;
    unsigned toUInt(const std::string &s) const;
    double   toDouble(const std::string &s) const;

    std::string toString(bool i) const;
    std::string toString(int i) const;
    std::string toString(unsigned i) const;
    std::string toString(double i) const;

  private:
    std::locale loc;
  };
}

#endif // ! FANCYBASE_NUMERICCONVERTER_H
