// This may look like C code, but it is really -*- C++ -*-
/****************************************************************************
** $Id: fancyprocess.h 100 2008-01-25 17:12:50Z wglas $
**
** Copyright (C) 2003 EV-i Informationstechnologie GmbH
**
** Author: Wolfgang Glas / EV-i
**
** Wrapper class for a subprocess started by our application.
** 
*****************************************************************************/

#ifndef FANCYBASE_PROCESS_H
#define FANCYBASE_PROCESS_H

#include <fancybase.h>

namespace Fancy {
  class FileHandle;
  class ProcessPrivate;

  class FANCYBASE_API Process
  {
    ProcessPrivate *d;

  public:
    Process();

    ~Process();

    bool isStarted() const;

    long getId() const;
    
    void start(const char *path, const char *argv[],
               FileHandle *stdinHandle,
               FileHandle *stdoutHandle,
               FileHandle *stderrHandle );

#ifndef WIN32
    bool fork(FileHandle *stdinHandle,
              FileHandle *stdoutHandle,
              FileHandle *stderrHandle);
#endif

    void kill(int signal);

    void wait(int *status);
  };

}

#endif
