// This may look like C code, but it is really -*- C++ -*-
/****************************************************************************
** $Id: fancysignal.h 87 2007-12-18 17:11:32Z wglas $
**
** Copyright (C) 2003 EV-i Informationstechnologie GmbH
**
** Author: Wolfgang Glas / EV-i
**
** Global signal handling stuff.
** 
*****************************************************************************/

#ifndef FANCYBASE_SIGNAL_H
#define FANCYBASE_SIGNAL_H

#include <sys/types.h>
#include <fancybase.h>

namespace Fancy {

  FANCYBASE_API void installSignalHandlers();
  FANCYBASE_API void installNewHandler(size_t reserve);

  FANCYBASE_API void mallocFailHandler();

  FANCYBASE_API void sendSignal(int sig);

#ifdef WIN32
  FANCYBASE_API void *getSignalWinEventHandle();
#endif

  FANCYBASE_API void resetHupSignalCatched();
  FANCYBASE_API int getHupSignalCatched();

  FANCYBASE_API void resetStopSignalCatched();
  FANCYBASE_API int getStopSignalCatched();

  FANCYBASE_API void resetUsrSignalCatched();
  FANCYBASE_API int getUsrSignalCatched();

}

#endif // ! FANCYBASE_SIGNAL_H
